/*
 * neural.h
 *
 *  Created on: May 26, 2009
 *      Author: vfedyashov
 *
 *  Complete structure of neural network
 */

#ifndef NEURAL_H_
#define NEURAL_H_
#define HIDDEN_NEURONS 1000

#include <iostream>
#include <math.h>
#include <vector>

using namespace std;

struct TrainPair
{
	double *inputVector;
	double *desiredOutput;
};

typedef vector<TrainPair*> TrainingSet;

class Weight
{
public:
    Weight(double val = 0.0 );
    virtual ~Weight();

    double value;
};

typedef vector<Weight*> VectorWeights;

class Connection
{
public:
    Connection(int neuron = ULONG_MAX, int weight = ULONG_MAX);
    virtual ~Connection();

    int NeuronIndex;
    int WeightIndex;
};

typedef vector<Connection*> VectorConnections;

// Descripancy
/*class Accuracy
{
public:
	Accuracy(double val = 0.0);
	virtual ~Accuracy();
	double value;
};*/

//typedef vector<Accuracy*> VectorAccuracies;

class Neuron
{
public:
    Neuron();
    virtual ~Neuron();

    void AddConnection( int iNeuron, int iWeight );
    void AddConnection( Connection const & conn );

    double output;

    VectorConnections m_Connections;
//    Accuracy* accur;
};

typedef vector<Neuron*> VectorNeurons;


class Layer
{
public:
    Layer(Layer* pPrev = NULL );
    virtual ~Layer();

    void Calculate();

    void Backpropagate(vector< double >& dErr_wrt_dXn /* in */,
        vector< double >& dErr_wrt_dXnm1 /* out */,
        double etaLearningRate );

    Layer* m_pPrevLayer;
    VectorNeurons m_Neurons;
    VectorWeights m_Weights;
};

typedef vector<Layer*> VectorLayers;

class NeuralNetwork
{
public:
    VectorLayers m_Layers;
    double m_etaLearningRate;

    NeuralNetwork();
/*    NeuralNetwork(int number_Of_Layers, double eta)
    {
    	for (int i = 0; i < number_Of_Layers; i++) m_Layers.push_back(new Layer());
    	m_etaLearningRate = eta;
    }*/
    void Init(int number_Of_Layers, int *neurons_Per_Layer);
    virtual ~NeuralNetwork();

    void FeedForward( double* inputVector, int iCount,
        double* outputVector = NULL, int oCount = 0 );

    void Backpropagate( double *actualOutput,
         double *desiredOutput);

};


//Sigmoid saturation function (tanh)
double G(double x);

//Derivative
double difG(double x);

int NN_Train(NeuralNetwork *nn, double eps, int iCountMax, TrainingSet *TS, int n, int *npl);

double Err(double *actualOutput, double *desiredOutput);

#endif /* NEURAL_H_ */
